unit DJTSatLib_TLB;

// ************************************************************************ //
// WARNING                                                                  //
// -------                                                                  //
// The types declared in this file were generated from data read from a     //
// Type Library. If this type library is explicitly or indirectly (via      //
// another type library referring to this type library) re-imported, or the //
// 'Refresh' command of the Type Library Editor activated while editing the //
// Type Library, the contents of this file will be regenerated and all      //
// manual modifications will be lost.                                       //
// ************************************************************************ //

// PASTLWTR : $Revision:   1.11.1.75  $
// File generated on 08/09/2001 12:06:10 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\Davids\Delphi5\Radio\WXtrack\Component-V3\Source\djtsatlib.dll
// IID\LCID: {B670A920-E488-11D4-ADE9-00A0CC5AA94A}\0
// Helpfile: 
// HelpString: David Taylor's Satellite Component Library
// Version:    3.1
// ************************************************************************ //

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLASS_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
const
  LIBID_DJTSatLib: TGUID = '{B670A920-E488-11D4-ADE9-00A0CC5AA94A}';
  IID_ISatellites: TGUID = '{B670A922-E488-11D4-ADE9-00A0CC5AA94A}';
  CLASS_Satellites: TGUID = '{664FD442-E48A-11D4-ADE9-00A0CC5AA94A}';
type

// *********************************************************************//
// Forward declaration of interfaces defined in Type Library            //
// *********************************************************************//
  ISatellites = interface;
  ISatellitesDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
// *********************************************************************//
  Satellites = ISatellites;


// *********************************************************************//
// Interface: ISatellites
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {B670A922-E488-11D4-ADE9-00A0CC5AA94A}
// *********************************************************************//
  ISatellites = interface(IDispatch)
    ['{B670A922-E488-11D4-ADE9-00A0CC5AA94A}']
    function Get_VersionString: WideString; safecall;
    function Get_KeplerPath: WideString; safecall;
    procedure Set_KeplerPath(const Value: WideString); safecall;
    function Get_SatCount: Integer; safecall;
    function Get_SatNames: WideString; safecall;
    function Get_ObsLat: Double; safecall;
    procedure Set_ObsLat(Value: Double); safecall;
    function Get_ObsLon: Double; safecall;
    procedure Set_ObsLon(Value: Double); safecall;
    function Get_ObsHeight: Double; safecall;
    procedure Set_ObsHeight(Value: Double); safecall;
    function PassListForPeriod(const Name: WideString; UTCdate: Double; MinSeconds: Integer; 
                               NumDays: Integer; MinElevDegrees: Double): WideString; safecall;
    function IsVisible(const Name: WideString; JulianTime: Double; ThresholdDeg: Double; 
                       out Southbound: WordBool; out Azumuth: Double; out Elevation: Double; 
                       out Longitude: Double; out Latitude: Double; out Range: Double; 
                       out RangeRate: Double; out Altitude: Double; out Phase: Double): WordBool; safecall;
    function DateTimeToJT(DateTime: Double): Double; safecall;
    function Get_RevNumber: Integer; safecall;
    function Get_OrbitPhase: Double; safecall;
    function FindAOS(const Name: WideString; PredictTime: Double): Double; safecall;
    function FindLOS(const Name: WideString; PredictTime: Double): Double; safecall;
    function Get_MeanAnomaly: Double; safecall;
    property VersionString: WideString read Get_VersionString;
    property KeplerPath: WideString read Get_KeplerPath write Set_KeplerPath;
    property SatCount: Integer read Get_SatCount;
    property SatNames: WideString read Get_SatNames;
    property ObsLat: Double read Get_ObsLat write Set_ObsLat;
    property ObsLon: Double read Get_ObsLon write Set_ObsLon;
    property ObsHeight: Double read Get_ObsHeight write Set_ObsHeight;
    property RevNumber: Integer read Get_RevNumber;
    property OrbitPhase: Double read Get_OrbitPhase;
    property MeanAnomaly: Double read Get_MeanAnomaly;
  end;

// *********************************************************************//
// DispIntf:  ISatellitesDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {B670A922-E488-11D4-ADE9-00A0CC5AA94A}
// *********************************************************************//
  ISatellitesDisp = dispinterface
    ['{B670A922-E488-11D4-ADE9-00A0CC5AA94A}']
    property VersionString: WideString readonly dispid 1;
    property KeplerPath: WideString dispid 2;
    property SatCount: Integer readonly dispid 3;
    property SatNames: WideString readonly dispid 4;
    property ObsLat: Double dispid 5;
    property ObsLon: Double dispid 6;
    property ObsHeight: Double dispid 7;
    function PassListForPeriod(const Name: WideString; UTCdate: Double; MinSeconds: Integer; 
                               NumDays: Integer; MinElevDegrees: Double): WideString; dispid 8;
    function IsVisible(const Name: WideString; JulianTime: Double; ThresholdDeg: Double; 
                       out Southbound: WordBool; out Azumuth: Double; out Elevation: Double; 
                       out Longitude: Double; out Latitude: Double; out Range: Double; 
                       out RangeRate: Double; out Altitude: Double; out Phase: Double): WordBool; dispid 9;
    function DateTimeToJT(DateTime: Double): Double; dispid 10;
    property RevNumber: Integer readonly dispid 11;
    property OrbitPhase: Double readonly dispid 12;
    function FindAOS(const Name: WideString; PredictTime: Double): Double; dispid 13;
    function FindLOS(const Name: WideString; PredictTime: Double): Double; dispid 14;
    property MeanAnomaly: Double readonly dispid 15;
  end;

  CoSatellites = class
    class function Create: ISatellites;
    class function CreateRemote(const MachineName: string): ISatellites;
  end;

implementation

uses ComObj;

class function CoSatellites.Create: ISatellites;
begin
  Result := CreateComObject(CLASS_Satellites) as ISatellites;
end;

class function CoSatellites.CreateRemote(const MachineName: string): ISatellites;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Satellites) as ISatellites;
end;

end.
